#!/usr/bin/perl -T
use strict;
use warnings;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use SemaforeFile;
use CGI qw(:standard :netscape);
if (param('action') && param('action') eq 'load')
{
    &print_header("Elchemea Analytical",-onload=>'set_data()');
    my @data = ();
    my @fdata = ();
    my $name = '';
    my @model = ();
    eval 
    {
	my $fn = Impedance::IMPCGI::file_upload('filename');
	if ($fn)
	{
	    my $f = SemaforeFile->new($fn);
	    my @lines = $f->readlines();
	    foreach my $l (@lines)
	    {
		$l =~ s/\r//g;
	    }
	    my $x = 0;
	    while ($x < @lines && $lines[++$x] !~ /^\#{3} File/)
	    {
		# Do nothing #
	    }
	    $x++;
	    if ($lines[$x] !~ /\#/)
	    {
		$name = $lines[$x];
	    }
	    else
	    {
		$x--;
	    }
	    while ($x < @lines && $lines[++$x] !~ /^\#{3} Data/)
	    {
		# Do nothing #
	    }	    
	    while ($x < @lines && $lines[++$x] !~ /^\#/)
	    {
		push @data,$lines[$x];
	    }
	    while ($x < @lines && $lines[++$x] !~ /^\#{3} Impedance/)
	    {
		# Do nothing #
	    }
	    while ($x < @lines && $lines[++$x] !~ /^\#/)
	    {
		push @model,$lines[$x];
	    }
	    while ($x < @lines && $lines[++$x] =~ /^\#/)
	    {
		# Do nothing #
	    }
#	    unless (1)
#	    {
		while ($x < @lines && $lines[++$x] !~ /^\#{3} Fit/)
		{
		    push @fdata,$lines[$x];
		}
#	    }
	    unlink $f->filename if ($f->exist);
	}
    };
    my $data = join("\n",@data);
    my $fdata = join("\n",@fdata);
    my $model = join("\n",@model);
    my $mode = 'simulation';
    $mode = 'plot' if ($data);
    print start_form(-name=>'sofc');
    print hidden(-name=>'data',-value=>$data,-force=>1);
    print hidden(-name=>'filedata',-value=>$fdata,-force=>1);
    print hidden(-name=>'model',-value=>$model,-force=>1);
    print hidden(-name=>'filename',-value=>$name,-force=>1);
    print hidden(-name=>'allow_close',-value=>1,-force=>1);
    print hidden(-name=>'mode',-value=>$mode,-force=>1);
    print end_form();

    print <<END;

<script language="javascript">

function set_data()
{
    opener.document.sofc.data.value = document.sofc.data.value;
    opener.document.sofc.filedata.value = document.sofc.filedata.value;
    opener.document.sofc.model.value = document.sofc.model.value;
    opener.document.sofc.filename.value = document.sofc.filename.value;
    opener.document.sofc.mode.value = document.sofc.mode.value;
    opener.document.sofc.submit();
    self.close();
}

</script>

END
    
    print end_html();
exit;
}

#&print_header("Elchemea Analytical",-onBlur=>'initiateSelfClosing()');
&print_header("Elchemea Analytical");
print center(h1("Load model file"));
print '<center><table border=0 cellspacing=20 width=100%><tr>';
print '<td width=70%>';
print start_form(-name=>'select');
print filefield(-name=>'filename',-class=>'textfield',-onchange=>'document.select.submit()');
print_hidden();
&action('load');
print end_form();
print '</td>';
end_top_bar();
print '</center>';
print end_html();
exit;

